## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 18;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global forgeurl https://github.com/BenHanson/lexertl14
%global commit 86c90c37dd69ee45155d11e38a77b21eac5dccbe

Name:           lexertl14
Summary:        The Modular Lexical Analyser Generator
Version:        0.1.0
%forgemeta
Release:        %autorelease

URL:            %{forgeurl}
License:        BSL-1.0
Source0:        %{forgesource}

# Fix install paths on Linux with multilib
# https://github.com/BenHanson/lexertl14/pull/20
Patch:          %{url}/pull/20.patch

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  dos2unix

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%global common_description %{expand:
lexertl is a header-only library for writing lexical analysers. With lexertl
you can:

  • Build lexical analysers at runtime
  • Scan Unicode and ASCII input
  • Scan from files or memory
  • Generate C++ code or even write your own code generator}

%description %{common_description}


%package devel
Summary:        %{summary}

# Header-only library:
Provides:       lexertl14-static = %{version}-%{release}

%description devel %{common_description}


%package examples
Summary:        Examples for lexertl14
BuildArch:      noarch

%description examples
%{summary}.


%prep
%forgeautosetup -p1
# Fix line terminations (particularly for files that may be installed)
find . -type f -exec file '{}' '+' |
  grep -E '\bCRLF\b' |
  cut -d ':' -f 1 |
  xargs -r dos2unix


%build
%cmake -DBUILD_TESTING:BOOL=on
%cmake_build


%install
%cmake_install


%check
%ctest


%files devel
%license include/lexertl/licence_1_0.txt
%doc README.md

%{_includedir}/lexertl/

%{_libdir}/cmake/lexertl/


%files examples
%license include/lexertl/licence_1_0.txt
%doc examples/*


%changelog
* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-18
- Use a proper patch to fix multilib paths, and offer it upstream

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-16
- Improve the Summary

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-15
- Update to 86c90c3 (Restore the ability to run tests with BUILD_TESTING
  and ctest)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-14
- Update to 5bd3180
- Changed from std::size_t to uint16_t for ease of use
- Added missing #include and functions
- regex macro BOL and EOL fixes
- Added exit state syntax check for missing right chevron

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-13
- Update to c4bcaf8
- More SonarLint etc changes
- Applied SA changes
- Added tests

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-12
- Update to 2e2893c
- Added replace.hpp
- Now throwing exception in case of stack underflow
- Updated serialization support
- More use of auto
- Use cend()
- More UTF-32 support
- Added stream_num.hpp
- Fixed #include

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-11
- Update to aeddda8 (Unicode 15.1.0 and other minor enhancements)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-10
- Indicate dirs. in files list with trailing slashes

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-9
- Update to 8b8ead2 (Update to the latest Unicode standard)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-8
- Update License to SPDX

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-7
- Update to cd5a1f1 (Unicode 15)

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-6
- Update to 2ea71b8

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-5
- Dep. on cmake-filesystem is now auto-generated

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-4
- Update to commit 488602f

* Wed Aug 25 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-1
- Initial package for EPEL8

